clear 
close all
load('traiX.mat');
load('queryX.mat');
load('T.mat');

%%% ̃p[^
reg.type = 't'; %'t':TikhonovC'r':Nጸ(TSVD)C'm':CQ
reg.mu = 1e-6;  % p[^
reg.rank = 9;   % N
reg.delta = 1e-3; % ^xCYdelta

ntrai = size(trai.X,2); %W{
d = size(trai.X,1); %
nquery = length( query.label); %eXgW{
nclass = max(trai.label);
imgsize = [112 92];

for c=1:nclass
  %% wKpW{eNX̕ρCUU߂
  index = find( trai.label == c );
  Class(c).m = mean( trai.X(:,index), 2 );
  Class(c).S = cov( trai.X(:,index)' ); 
  
  %% 
  switch reg.type
   case 't'
    A = inv(chol( Class(c).S + reg.mu * eye(d) )');
    b = sum( log( eig(Class(c).S + reg.mu * eye(d)) ) );
   case 'r'
    [V D] = eig(Class(c).S);
    [d index] = sort(diag(D),'descend');
    A = diag( 1./sqrt(d(1:reg.rank)) ) * V(:, index(1:reg.rank))';
    b = sum( log( d(1:reg.rank) ) );
   case 'm'
    [V D] = eig(Class(c).S);
    A = diag( 1./ sqrt( max( reg.delta, diag(D) ) ) ) * V';
    b = sum( log( max( reg.delta, diag(D) ) ) );
   otherwise
    error(sprintf('reg.type = %c is not implemented\n',reg.type));
  end
  
  %% m̑ΐvZ
  feature(c,:) = -sum( ( A*(query.X - Class(c).m*ones(1,nquery)) ).^2 ) - b;
end

[tmp eclass] = max(feature);
accuracy = sum(eclass(:) == query.label(:))/nquery;
fprintf('accuracy = %.2f %%\n',accuracy*100 );

%% 뎯ʂ̂\
index = find( eclass(:) ~= query.label(:) );
figure,colormap('gray');
for ii=1:min(length(index),9)
  subplot(3,3,ii);
  imagesc( reshape( T.m + T.U*query.X(:,index(ii)), imgsize(1), imgsize(2) ) );
end
